//*********************************************************
//
// Copyright (c) Microsoft. All rights reserved.
// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************
//
// DeadlockExample.cpp
//

#include "stdafx.h"
#include <Windows.h>
#include <atlbase.h>

CComCriticalSection g_lock;
HANDLE g_threadReadyEvent;
HANDLE g_readyToGoEvent;

CComCriticalSection g_locks[16];

int FuncEvalFunction(int token)
{
	// Tell the blocking worker thread to continue and release the lock
	SetEvent(g_readyToGoEvent);
	g_lock.Lock();
	g_lock.Unlock();

	return token;
}

DWORD WINAPI BasicThreadProc(LPVOID param)
{
	g_lock.Lock();

	SetEvent(g_threadReadyEvent);                       // Tell main thread we are ready
	::WaitForSingleObject(g_readyToGoEvent, INFINITE);  // Wait for FuncEval to happen

	g_lock.Unlock();

	return 0;
}

void BasicScenario()
{
	CHandle hThread;
	hThread.Attach(::CreateThread(nullptr, 0, BasicThreadProc, 0, 0, nullptr));
	::WaitForSingleObject(g_threadReadyEvent, INFINITE);

	::WaitForSingleObject(hThread, INFINITE);					// Set breakpoint here
}

int wmain(int argc, wchar_t* argv[])
{
	g_lock.Init();
	for (DWORD_PTR i = 0; i < _countof(g_locks); ++i)
	{
		g_locks[i].Init();
	}
	g_threadReadyEvent = ::CreateEvent(nullptr, FALSE/*bManualReset*/, FALSE/*bInitialState*/, nullptr);
	g_readyToGoEvent = ::CreateEvent(nullptr, FALSE/*bManualReset*/, FALSE/*bInitialState*/, nullptr);

	BasicScenario();

	return 0;
}


